// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, SuggestedKind};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsSuggested")]
    pub struct Suggested(Object<ffi::AsSuggested, ffi::AsSuggestedClass>);

    match fn {
        type_ => || ffi::as_suggested_get_type(),
    }
}

impl Suggested {
    pub const NONE: Option<&'static Suggested> = None;

    #[doc(alias = "as_suggested_new")]
    pub fn new() -> Suggested {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_suggested_new()) }
    }
}

impl Default for Suggested {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Suggested>> Sealed for T {}
}

pub trait SuggestedExt: IsA<Suggested> + sealed::Sealed + 'static {
    #[doc(alias = "as_suggested_add_id")]
    fn add_id(&self, cid: &str) {
        unsafe {
            ffi::as_suggested_add_id(self.as_ref().to_glib_none().0, cid.to_glib_none().0);
        }
    }

    #[doc(alias = "as_suggested_get_ids")]
    #[doc(alias = "get_ids")]
    fn ids(&self) -> Vec<glib::GString> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(ffi::as_suggested_get_ids(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_suggested_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> SuggestedKind {
        unsafe { from_glib(ffi::as_suggested_get_kind(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_suggested_is_valid")]
    fn is_valid(&self) -> bool {
        unsafe { from_glib(ffi::as_suggested_is_valid(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_suggested_set_kind")]
    fn set_kind(&self, kind: SuggestedKind) {
        unsafe {
            ffi::as_suggested_set_kind(self.as_ref().to_glib_none().0, kind.into_glib());
        }
    }
}

impl<O: IsA<Suggested>> SuggestedExt for O {}
